<template>
  <div class="row q-col-gutter-sm">
    <div class="col-md-7 col-xs-12">
      <q-card class="q-mt-sm">
        <q-card-section>
          <div class="q-gutter-md">
            <InputBuscar
              v-model="formData.persona_uuid"
              dense
              filled
              label="Seleccionar Persona:"
              hide-bottom-space
              :error="validacion.has('persona_uuid')"
              :error-message="validacion.first('persona_uuid')"
            />

            <SelectRama
              v-model="formData.rama"
              dense
              filled
              :multiple="false"
              label="Rama: "
              hide-bottom-space
              :error="validacion.has('rama')"
              :error-message="validacion.first('rama')"
            />

            <q-input
              v-if="formData.uuid"
              v-model="formData.nro_registro"
              label="Nro de Registro Saac"
              dense
              filled
              :error="validacion.has('nro_registro')"
              :error-message="validacion.first('nro_registro')"
            >
              <template v-slot:prepend>
                <q-icon name="numbers" />
              </template>
            </q-input>

            <InputDate
              v-if="formData.uuid"
              v-model="formData.f_otorgada"
              label="Fecha Otorgada"
              hide-bottom-space
              :error="validacion.has('f_otorgada')"
              :error-message="validacion.first('f_otorgada')"
            />
          </div>

          <div class="row q-col-gutter-xs q-mt-sm">
            <div class="col-12">
              <q-btn
                v-if="formData.uuid"
                @click="submitUpdate"
                class="full-width"
                color="green"
              >
                Finalizar carga
              </q-btn>

              <q-btn
                v-if="!formData.uuid"
                @click="submitCrear"
                class="full-width"
                color="green"
              >
                Solicitar nueva IM
              </q-btn>
            </div>
          </div>

          <Loading :showing="loading" />
        </q-card-section>
      </q-card>
    </div>
    <div class="col-md-5 col-xs-12">
      <InsigniaMaderaDetalle
        v-if="formData.persona_uuid"
        :uuid="formData.persona_uuid"
        titulo="Insignias de madera actuales"
      />
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, onMounted } from 'vue';
import { api, validacion } from 'src/boot/axios/index';
import { AxiosResponse } from 'axios';
import { useRoute, useRouter } from 'vue-router';
import { Im } from 'src/interfaces/InsigniaDeMaderaInterface';
import InputBuscar from 'components/Personas/InputBuscar.vue';
import SelectRama from 'components/Form/selectRama.vue';
import InputDate from 'components/Form/InputDate.vue';
import Loading from 'src/components/Loading.vue';

import InsigniaMaderaDetalle from 'components/Formacion/InsigniaMaderaDetalle.vue';

export default defineComponent({
  name: 'InsigniaDeMaderasFormulario',
  components: {
    Loading,
    InsigniaMaderaDetalle,
    InputBuscar,
    InputDate,
    SelectRama,
  },
  setup() {
    // const router = useRouter();
    const router = useRouter();
    const route = useRoute();
    const uuid = String(
      route.params.uuid === undefined ? '' : route.params.uuid
    );

    const loading = ref(false);
    const formData = ref({
      uuid: null,
      persona_uuid: null,
      rama: null,
      nro_registro: null,
      f_otorgada: null,
    });

    onMounted(() => {
      if (uuid != '') {
        // si paso un uuid, primero tengo que obtener el evento, para saber que tipo de area es
        getDatos();
      }
    });

    function getDatos() {
      loading.value = true;
      api
        .get<Im>('/api/formacion/im/' + uuid + '/editar')
        .then((response: AxiosResponse) => {
          formData.value = response.data;
        })
        .finally(() => {
          loading.value = false;
        });
    }

    function submitCrear() {
      loading.value = true;
      api
        .post('/api/formacion/im', formData.value)
        .then(() => {
          router.push({ path: '/formacion/insignia_de_madera' });
        })
        .finally(() => {
          loading.value = false;
        });
    }

    function submitUpdate() {
      loading.value = true;
      api
        .put('/api/formacion/im', formData.value)
        .then(() => {
          router.push({ path: '/formacion/insignia_de_madera' });
        })
        .finally(() => {
          loading.value = false;
        });
    }

    return { uuid, validacion, loading, formData, submitCrear, submitUpdate };
  },
});
</script>
